using System;

class UglyFamily
{
	const int STUDENTS_NUM = 10;
	static Random mark = new Random();
	static Student[] students = new Student[STUDENTS_NUM];
	static Parent parent = new Parent();
	static Voenkomat voenkomat = new Voenkomat();

	class Student
	{
		public virtual int ExamMark()
		{
			return mark.Next(2, 4);
		}

		public delegate void ParentsEventHandler(int Mark, int MoneyQuantity);
		public void AfterExam(ParentsEventHandler handler)
		{
			int Mark = ExamMark();
			handler(Mark, Mark*20);
		}
	}

	class AdvancedStudent : Student
	{
		public override int ExamMark()
		{
			Random mark = new Random();
			return mark.Next(2, 6);
		}
	}

	class Parent
	{
		public void MarksLookup(int Mark, int MoneyQuantity)
		{
			Console.WriteLine("My child passed exam for {0} and wants {1} dollars",
				Mark, MoneyQuantity);
		}
	}

	class Voenkomat
	{
		public void LookupNewSoldier(int Mark, int Pofig)
		{
			if(2 == Mark)
			{
				Console.WriteLine("   , !");
			}
			else
			{
				Console.WriteLine("  ,   ...=(");
			}
			Console.WriteLine();
		}
	}

	static void ProceedStudents()
	{
		Student.ParentsEventHandler handler = new Student.ParentsEventHandler(parent.MarksLookup);
		Student.ParentsEventHandler handler2 = new Student.ParentsEventHandler(voenkomat.LookupNewSoldier);

		foreach (Student student in students)
		{
		    student.AfterExam(handler);
		    student.AfterExam(handler2);
		}
	}

	[STAThread]
	static void Main()
	{
		for(int i = 0; i < STUDENTS_NUM; ++i)
		{
			if(mark.Next(2) == 0)
			{
				students[i] = new Student();
			}
			else
			{
				students[i] = new AdvancedStudent();
			}
		}
		ProceedStudents();
	}
}